; ------------------------------------------------------------
;+ 02-10-95 09:21:05am
;+ Center for Information Management
; ------------------------------------------------------------
Proc HelpZoom()
   Private ProcName
   ProcName = "HelpZoom"
   ValueVar = ""
  ; PaintPAL_Generated_Code_Begin(508185266)

  SHOWDIALOG "Help Search"
     @7,11 HEIGHT 9 WIDTH 56

     PAINTCANVAS FILL "" ATTRIBUTE 112 0,0,6,53

     ; PaintPAL_Static_Text_Begin
     PAINTCANVAS FILL " " ATTRIBUTE 112 2,5,2,11
     @2,5
     ?? "Value: "
     PAINTCANVAS ATTRIBUTE 112 2,5,2,11
     ; PaintPAL_Static_Text_End

     ACCEPT @2,12 WIDTH 38
        "A35"
        TAG "ValueTag"
        TO ValueVar

     PUSHBUTTON @5,12 WIDTH 10
        "~O~k"
        OK
        DEFAULT
        VALUE "Ok"
        TAG "OkButtonTag"
        TO WhichButton

     PUSHBUTTON @5,32 WIDTH 10
        "~C~ancel"
        CANCEL
        VALUE "Cancel"
        TAG "CancelButtonTag"
        TO WhichButton
  ENDDIALOG

  ; PaintPAL_Generated_Code_End(508185266)
  IF RetVal THEN
     RETURN ValueVar
  ELSE
     RETURN "NoZoom"
  ENDIF
Endproc

; ------------------------------------------------------------
;+ 02-10-95 10:18:18am
;+ Center for Information Management
; ------------------------------------------------------------
Proc HelpYesNo()
   Private ProcName
   ProcName = "HelpYesNo"
   ; PaintPAL_Generated_Code_Begin(508517545)

   SHOWDIALOG "WARNING!!!"
      @7,14 HEIGHT 10 WIDTH 50

      PAINTCANVAS FILL "" ATTRIBUTE 112 0,0,7,47

      ; PaintPAL_Static_Text_Begin
      PAINTCANVAS FILL " " ATTRIBUTE 78 1,6,3,41
      @1,6
      ?? "There are no items in the New Menu."
      @2,6
      ?? " Do you wish to continue generating"
      @3,6
      ?? "           the new menu?"
      PAINTCANVAS ATTRIBUTE 78 1,6,3,41
      ; PaintPAL_Static_Text_End

      PUSHBUTTON @6,9 WIDTH 10
         "~Y~es"
         OK
         VALUE "Ok"
         TAG "OkButtonTag"
         TO WhichButton

      PUSHBUTTON @6,29 WIDTH 10
         "~N~o"
         CANCEL
         DEFAULT
         VALUE "Cancel"
         TAG "CancelButtonTag"
         TO WhichButton
   ENDDIALOG

   ; PaintPAL_Generated_Code_End(508517545)
   RETURN RetVal
Endproc

; ------------------------------------------------------------
;+ 02-10-95 08:03:02am
;+ Center for Information Management
; ------------------------------------------------------------
Proc CustMenuDlgHelp()
   ; This procedure is adapted from a procedure written by Ensemble Corp.
   ; for their Renaissance product
   PRIVATE  HelpWin, HelpEvent, HelpKey, CanClose, WinAttr, DlgWin,
            Done, HelpProps, ProcName
   ProcName = "CustMenuDlgHelp"

   ECHO OFF
   ; Move the CustMenu dialog box off the screen
   WINDOW HANDLE Dialog TO DlgWin
   WINDOW MOVE DlgWin TO 100, 100
   ECHO NORMAL
   EDITOR OPEN "CUSTMENU.HLP"
   CTRLPGUP
   ; HelpWin is the Editor Window
   HelpWin = GETWINDOW()
   DynArray HelpProps[]
   HelpProps["Floating"] = True
   HelpProps["Title"] = "Custom Utility Menu Help"
   WINDOW SETATTRIBUTES HelpWin FROM HelpProps
   WINDOW GETATTRIBUTES HelpWin TO WinAttr
   IF WinAttr["CanClose"] AND WinAttr["HasFrame"] THEN
      CanClose = TRUE
   ELSE
      CanClose = FALSE
   ENDIF
   ; Pulldown menu for the help window
   SHOWPULLDOWN
      "" : "" : "",
      "~S~earch" : "" : ""
        SUBMENU
          "Find ~F~irst  [Ctrl-Z]" : "Find the first occurrance of a value." : "Zoom",
          "Find ~N~ext   [Alt-Z]"  : "Find the next occurrance of a value." : "ZoomNext"
        ENDSUBMENU,
      "~P~rint" : "Print this text." : "Print",
      "~C~lose" : "Close the help window." : "Back"
   ENDMENU

   Done = FALSE
   ;Process events while in the help window
   WHILE NOT Done
      WHILE TRUE
         GETEVENT KEY "All" MOUSE "Down" MESSAGE "MENUSELECT" TO HelpEvent
         SWITCH
            CASE HelpEvent["Type"] = "KEY" :
               HelpKey = HelpEvent["KeyCode"]
               SWITCH
                  CASE HelpKey = 27 OR HelpKey = -60 OR HelpKey = -101 :
                     Done = TRUE
                     QUITLOOP
                  CASE (HelpKey >= -119 AND HelpKey <= -115) OR
                         (HelpKey >= -81 AND HelpKey <= -71) OR
                         HelpKey = -88 OR HelpKey = -98 :
                     EXECEVENT HelpEvent
                  CASE HelpKey = 26 : ; Ctrl-Z
                     ; Check the return value from the HelpZoom dialog box
                     Ret = HelpZoom()
                     IF Ret <> "NoZoom" THEN
                        ZOOM CTRLBACKSPACE TYPEIN Ret ENTER
                        ECHO NORMAL
                     ENDIF
                  CASE HelpKey = -44 : ; Alt-Z
                     ZOOMNEXT
               ENDSWITCH
            CASE HelpEvent["Type"] = "MOUSE" :
               IF HelpEvent["Action"] = "DOWN" THEN
                  IF WINDOWAT(HelpEvent["Row"], HelpEvent["Col"]) = HelpWin THEN
                     IF CanClose THEN
                        WINDOW GETATTRIBUTES HelpWin TO WinAttr
                        IF HelpEvent["Row"] = WinAttr["OriginRow"] AND
                              (HelpEvent["Col"] >= WinAttr["OriginCol"] + 2 AND
                              HelpEvent["Col"] <= WinAttr["OriginCol"] + 4) THEN
                           Done = TRUE
                           QUITLOOP
                        ENDIF
                     ENDIF
                     EXECEVENT HelpEvent
                  ELSE
                     Done = TRUE
                     QUITLOOP
                  ENDIF
               ENDIF
            CASE HelpEvent["Type"] = "MESSAGE" AND HelpEvent["Message"] = "MENUSELECT" :
               SWITCH
                  CASE HelpEvent["MenuTag"] = "Back" :
                     Done = TRUE
                     QUITLOOP
                  CASE HelpEvent["MenuTag"] = "Zoom" :
                     ; Check the return value from the HelpZoom dialog box
                     Ret = HelpZoom()
                     IF Ret <> "NoZoom" THEN
                        ZOOM CTRLBACKSPACE TYPEIN Ret ENTER
                        ECHO NORMAL
                     ENDIF
                  CASE HelpEvent["MenuTag"] = "ZoomNext" :
                     ZOOMNEXT
                  CASE HelpEvent["MenuTag"] = "Print" :
                     MESSAGE "Printing..."
                     ECHO OFF
                     MENU {FILE} {PRINT}
                     ECHO NORMAL
                     MESSAGE ""
               ENDSWITCH
         ENDSWITCH
      ENDWHILE
   ENDWHILE
   ; Cancel the Editor session
   MENU {CANCEL} {Yes}
   ECHO OFF
   ; Return the CustMenu dialog box to the screen
   WINDOW MOVE DlgWin TO 2, 0
   ; Remove the help pulldown menu
   SHOWPULLDOWN ENDMENU
Endproc

; ------------------------------------------------------------
;+ 02-10-95 08:03:02am
;+ Center for Information Management
; ------------------------------------------------------------
PROC CustMenuDlgProc(TriggerType, TagValue, EventValue, ElementValue)
   Private ProcName
   ProcName = "CustMenuDlgProc"
   SWITCH
      ; To update Item Detail area upon arrival on either menu array element
      CASE TriggerType = "ARRIVE":
         SWITCH
            CASE TagValue = "UtilMenuTag":
               ItemDetail[2] = FORMAT("W43,AL",UtilMenuDesc[UtilMenuVar]) +
                               FORMAT("W15,AL",UtilMenuTag[UtilMenuVar]) +
                               UtilMenuScript[UtilMenuVar]
               REFRESHCONTROL "ItemDetailTag"
            CASE TagValue = "TempMenuTag":
               ItemDetail[2] = FORMAT("W43,AL",TempMenuDesc[TempMenuVar]) +
                               FORMAT("W15,AL",TempMenuTag[TempMenuVar]) +
                               TempMenuScript[TempMenuVar]
               REFRESHCONTROL "ItemDetailTag"
         ENDSWITCH
      CASE TriggerType = "UPDATE":
         SWITCH
            ; To update Item Detail area upon moving to a new menu element -
            ; current menu
            CASE TagValue = "UtilMenuTag":
               ItemDetail[2] = FORMAT("W43,AL",UtilMenuDesc[EventValue]) +
                               FORMAT("W15,AL",UtilMenuTag[EventValue]) +
                               UtilMenuScript[EventValue]
               REFRESHCONTROL "ItemDetailTag"
            ; To update Item Detail area upon moving to a new menu element -
            ; new menu
            CASE TagValue = "TempMenuTag":
               ItemDetail[2] = FORMAT("W43,AL",TempMenuDesc[EventValue]) +
                               FORMAT("W15,AL",TempMenuTag[EventValue]) +
                               TempMenuScript[EventValue]
               REFRESHCONTROL "ItemDetailTag"
            ; Add new menu item
            CASE TagValue = "AddNewButtonTag":
               ; If item is not a separator, item name, tag and script name
               ; must be included
               IF (ItemVar = "" OR ItemTagVar = "" OR ScriptVar = "") AND
                        UPPER(ItemVar) <> "SEPARATOR" THEN
                  MESSAGE "Item, Item Tag and Script cannot be Blank!!"
                  RETURN
               ENDIF
               ; Check to see where ~'s are located - if not ~@~ then check
               ; if only one ~ exists
               IF NOT MATCH(ItemVar,"..~@~..") THEN
                  X = -1
                  FOR CPOS FROM 1 TO LEN(ItemVar)
                     IF SUBSTR(ItemVar,CPOS,1) = "~" THEN
                        X = CPOS
                        QUITLOOP
                     ENDIF
                  ENDFOR
                  ; If only one ~ exists, display error message
                  IF X <> -1 THEN
                     MESSAGE "Invalid Item Name!"
                     SLEEP 1000
                     MESSAGE ""
                     RETURN
                  ENDIF
               ENDIF
               ; Concatenate Item Tag and Script items
               ItemTagVar = XTRIM(ItemTagVar," ")
               ScriptVar = XTRIM(ScriptVar," ")
               ; Find the next blank new item number in the TempMenu array
               X = -1
               FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
                  IF TempMenu[Element] = "" THEN
                     X = Element
                     QUITLOOP
                  ENDIF
               ENDFOR
               IF X = -1 THEN
                  ; There are no spaces for new menu items
                  MESSAGE "The New Menu cannot hold any more items!!!"
                  SLEEP 2000
                  ItemVar = ""
                  DescVar = ""
                  ItemTagVar = ""
                  ScriptVar = ""
                  REFRESHCONTROL "ItemTag"
                  REFRESHCONTROL "DescTag"
                  REFRESHCONTROL "ItemTagTag"
                  REFRESHCONTROL "ScriptTag"
               ELSE
                  ; Assign the new items to the correct array elements
                  TempMenu[X] = ItemVar
                  IF UPPER(ItemVar) <> "SEPARATOR" THEN
                     TempMenuDesc[X] = DescVar
                     TempMenuTag[X] = ItemTagVar
                     TempMenuScript[X] = ScriptVar
                  ENDIF
                  REFRESHCONTROL "TempMenuTag"
                  ItemVar = ""
                  DescVar = ""
                  ItemTagVar = ""
                  ScriptVar = ""
                  REFRESHCONTROL "ItemTag"
                  REFRESHCONTROL "DescTag"
                  REFRESHCONTROL "ItemTagTag"
                  REFRESHCONTROL "ScriptTag"
               ENDIF
            CASE TagValue = "EditCurButtonTag":
               ; Copy the chosen menu item elements to the ACCEPT
               ; elements for editing
               EditType = "Current"
               ItemVar = UtilMenu[UtilMenuVar]
               DescVar = UtilMenuDesc[UtilMenuVar]
               ItemTagVar = UtilMenuTag[UtilMenuVar]
               ScriptVar = UtilMenuScript[UtilMenuVar]
               REFRESHCONTROL "ItemTag"
               REFRESHCONTROL "DescTag"
               REFRESHCONTROL "ItemTagTag"
               REFRESHCONTROL "ScriptTag"
            CASE TagValue = "EditNewButtonTag":
               ; Copy the chosen menu item elements to the ACCEPT
               ; elements for editing
               EditType = "New"
               ItemVar = TempMenu[TempMenuVar]
               DescVar = TempMenuDesc[TempMenuVar]
               ItemTagVar = TempMenuTag[TempMenuVar]
               ScriptVar = TempMenuScript[TempMenuVar]
               REFRESHCONTROL "ItemTag"
               REFRESHCONTROL "DescTag"
               REFRESHCONTROL "ItemTagTag"
               REFRESHCONTROL "ScriptTag"
            ; Delete a "New" menu item
            CASE TagValue = "DelNewButtonTag":
               IF ISBLANK(TempMenuVar) THEN
                  RETURN
               ENDIF
               CheckTest = False
               ; Check if the item is a Current Menu item
               FOR Element FROM 1 TO ARRAYSIZE(UtilMenu)
                  IF UtilMenu[Element] = "* "+TempMenu[TempMenuVar] THEN
                     ; If item is a Current Menu item, display error message
                     MESSAGE "This is NOT a NEW Menu item!"
                     SLEEP 1500
                     MESSAGE ""
                     CheckTest = True
                     QUITLOOP
                  ENDIF
               ENDFOR
               IF CheckTest THEN
                  CheckTest = False
                  RETURN
               ENDIF
               TempMenu[TempMenuVar] = ""
               TempMenuDesc[TempMenuVar] = ""
               TempMenuTag[TempMenuVar] = ""
               TempMenuScript[TempMenuVar] = ""
               REFRESHCONTROL "TempMenuTag"
            ; Add an item from the current menu to the new menu
            CASE TagValue = "AddButtonTag":
               IF ISBLANK(UtilMenuVar) THEN
                  RETURN
               ENDIF
               ; Cannot copy item which has already been copied
               IF SUBSTR(UtilMenu[UtilMenuVar],1,1) = "*" THEN
                  RETURN
               ENDIF
               ; Find the next empty array element for the new menu
               X = -1
               FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
                  IF TempMenu[Element] = "" THEN
                     X = Element
                     QUITLOOP
                  ENDIF
               ENDFOR
               IF X = -1 THEN
                  ; The new menu is full, display error message
                  MESSAGE "The New Menu cannot hold any more items!!!"
                  SLEEP 2000
                  ItemVar = ""
                  DescVar = ""
                  ItemTagVar = ""
                  ScriptVar = ""
                  REFRESHCONTROL "ItemTag"
                  REFRESHCONTROL "DescTag"
                  REFRESHCONTROL "ItemTagTag"
                  REFRESHCONTROL "ScriptTag"
               ELSE
                  TempMenu[X] = UtilMenu[UtilMenuVar]
                  TempMenuDesc[X] = UtilMenuDesc[UtilMenuVar]
                  TempMenuTag[X] = UtilMenuTag[UtilMenuVar]
                  TempMenuScript[X] = UtilMenuScript[UtilMenuVar]
                  UtilMenu[UtilMenuVar] = "* " + UtilMenu[UtilMenuVar]
                  REFRESHCONTROL "UtilMenuTag"
                  REFRESHCONTROL "TempMenuTag"
               ENDIF
            ; Remove an item from the new menu back to the present menu
            ; A "New" item cannot be processed this way because it cannot
            ; be written back to the present menu
            CASE TagValue = "RemoveButtonTag":
               IF ISBLANK(TempMenuVar) THEN
                  RETURN
               ENDIF
               CheckTest = False
               ; Find the correct current menu item which matches the
               ; New Menu
               FOR Element FROM 1 TO ARRAYSIZE(UtilMenu)
                  IF UtilMenu[Element] = "* "+TempMenu[TempMenuVar] THEN
                     ; If the current menu item is found, remove the *
                     ; and remove the new menu item
                     UtilMenu[Element] = TempMenu[TempMenuVar]
                     TempMenu[TempMenuVar] = ""
                     TempMenuDesc[TempMenuVar] = ""
                     TempMenuTag[TempMenuVar] = ""
                     TempMenuScript[TempMenuVar] = ""
                     REFRESHCONTROL "UtilMenuTag"
                     REFRESHCONTROL "TempMenuTag"
                     CheckTest = True
                     QUITLOOP
                  ENDIF
               ENDFOR
               IF NOT CheckTest THEN
                  MESSAGE "This is NOT an ORIGINAL Menu item!"
                  SLEEP 1500
                  MESSAGE ""
               ENDIF
               RETURN
            ; Save edited menu information
            CASE TagValue = "SaveButtonTag":
               ; If editing from the new menu, update array elements
               ItemTagVar = XTRIM(ItemTagVar," ")
               ScriptVar = XTRIM(ScriptVar," ")
               IF EditType = "New" THEN
                  TempMenu[TempMenuVar] = ItemVar
                  TempMenuDesc[TempMenuVar] = DescVar
                  TempMenuTag[TempMenuVar] = ItemTagVar
                  TempMenuScript[TempMenuVar] = ScriptVar
                  ItemDetail[2] = FORMAT("W43,AL",TempMenuDesc[TempMenuVar]) +
                                  FORMAT("W15,AL",TempMenuTag[TempMenuVar]) +
                                  TempMenuScript[TempMenuVar]
               ; If editing from the current menu, update array elements
               ; and rewrite array elements in the "MENARRAY.SC" file
               ELSE
                  OldItem = UtilMenu[UtilMenuVar]
                  OldTag = UtilMenuTag[UtilMenuVar]
                  UtilMenu[UtilMenuVar] = ItemVar
                  UtilMenuDesc[UtilMenuVar] = DescVar
                  UtilMenuTag[UtilMenuVar] = ItemTagVar
                  UtilMenuScript[UtilMenuVar] = ScriptVar
                  ItemDetail[2] = FORMAT("W43,AL",UtilMenuDesc[UtilMenuVar]) +
                                  FORMAT("W15,AL",UtilMenuTag[UtilMenuVar]) +
                                  UtilMenuScript[UtilMenuVar]
                  ; Change the correct array elements in MenArray.sc
                  EDITOR OPEN "MENARRAY.SC"
                  EDITOR FIND "UtilMenu[" + STRVAL(UtilMenuVar) + "]"
                  TYPEIN CHR(25)   ; CTRL-Y
                  EDITOR INSERT "  UtilMenu[" + STRVAL(UtilMenuVar) + "] = \"" + ItemVar + "\"\n"
                  EDITOR FIND "UtilMenuDesc[" +STRVAL(UtilMenuVar) + "]"
                  TYPEIN CHR(25)   ; CTRL-Y
                  EDITOR INSERT "  UtilMenuDesc[" + STRVAL(UtilMenuVar) + "] = \"" + DescVar + "\"\n"
                  EDITOR FIND "UtilMenuTag[" + STRVAL(UtilMenuVar) + "]"
                  TYPEIN CHR(25)   ; CTRL-Y
                  EDITOR INSERT "  UtilMenuTag[" + STRVAL(UtilMenuVar) + "] = \"" + ItemTagVar + "\"\n"
                  EDITOR FIND "UtilMenuScript[" + STRVAL(UtilMenuVar) + "]"
                  TYPEIN CHR(25)   ; CTRL-Y
                  EDITOR INSERT "  UtilMenuScript[" + STRVAL(UtilMenuVar) + "] = \"" + ScriptVar + "\"\n"
                  DO_IT!
                  ; Change the menu script to reflect the changes
                  EDITOR OPEN "UTILMENU.SC"
                  EDITOR FIND OldItem
                  TYPEIN CHR(25)   ; CTRL-Y
                  IF UPPER(UtilMenu[UtilMenuVar]) <> "SEPARATOR" THEN
                     EDITOR INSERT "      \""+UtilMenu[UtilMenuVar]+"\":\""+
                                   UtilMenuDesc[UtilMenuVar]+"\":\""+
                                   UtilMenuTag[UtilMenuVar]+"\",\n"
                  ELSE
                     EDITOR INSERT "   "+UtilMenu[UtilMenuVar]+","
                  ENDIF
                  EDITOR FIND OldTag
                  TYPEIN CHR(25)   ; CTRL-Y
                  TYPEIN CHR(25)   ; CTRL-Y
                  IF UPPER(UtilMenu[UtilMenuVar]) <> "SEPARATOR" THEN
                     EDITOR INSERT "      CASE PopChoice = \""+UtilMenuTag[UtilMenuVar]+"\":\n"+
                                   "         PLAY \""+UtilMenuScript[UtilMenuVar]+"\"\n"
                  ENDIF
                  DO_IT!
               ENDIF
               EditType = ""
               ItemVar = ""
               DescVar = ""
               ItemTagVar = ""
               ScriptVar = ""
               REFRESHCONTROL "UtilMenuTag"
               REFRESHCONTROL "TempMenuTag"
               REFRESHCONTROL "ItemDetailTag"
               REFRESHCONTROL "ItemTag"
               REFRESHCONTROL "DescTag"
               REFRESHCONTROL "ItemTagTag"
               REFRESHCONTROL "ScriptTag"
            CASE TagValue = "HelpButtonTag":
               ; Call the help procedure to display the help text
               CustMenuDlgHelp()
         ENDSWITCH
      CASE TriggerType = "SELECT":
         SWITCH
            ; Copy item from current menu to new menu
            CASE TagValue = "UtilMenuTag":
               ; Cannot copy item which has already been copied
               IF SUBSTR(UtilMenu[UtilMenuVar],1,1) = "*" THEN
                  RETURN
               ENDIF
               ; Find the next empty array element for the new menu
               FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
                  IF TempMenu[Element] = "" THEN
                     X = Element
                     QUITLOOP
                  ENDIF
               ENDFOR
               IF X = -1 THEN
                  ; The New Menu is full, display error message
                  MESSAGE "The New Menu cannot hold any more items!!!"
                  SLEEP 2000
                  ItemVar = ""
                  DescVar = ""
                  ItemTagVar = ""
                  ScriptVar = ""
                  REFRESHCONTROL "ItemTag"
                  REFRESHCONTROL "DescTag"
                  REFRESHCONTROL "ItemTagTag"
                  REFRESHCONTROL "ScriptTag"
               ELSE
                  TempMenu[X] = UtilMenu[UtilMenuVar]
                  TempMenuDesc[X] = UtilMenuDesc[UtilMenuVar]
                  TempMenuTag[X] = UtilMenuTag[UtilMenuVar]
                  TempMenuScript[X] = UtilMenuScript[UtilMenuVar]
                  UtilMenu[UtilMenuVar] = "* " + UtilMenu[UtilMenuVar]
                  REFRESHCONTROL "UtilMenuTag"
                  REFRESHCONTROL "TempMenuTag"
               ENDIF
            CASE TagValue = "TempMenuTag":
               IF ISBLANK(TempMenuVar) THEN
                  RETURN
               ENDIF
               CheckTest = False
               ; Find the correct element in the current menu
               FOR Element FROM 1 TO ARRAYSIZE(UtilMenu)
                  IF UtilMenu[Element] = "* "+TempMenu[TempMenuVar] THEN
                     ; If the element is found, remove the * and delete
                     ; the item from the New Menu
                     UtilMenu[Element] = TempMenu[TempMenuVar]
                     TempMenu[TempMenuVar] = ""
                     TempMenuDesc[TempMenuVar] = ""
                     TempMenuTag[TempMenuVar] = ""
                     TempMenuScript[TempMenuVar] = ""
                     REFRESHCONTROL "UtilMenuTag"
                     REFRESHCONTROL "TempMenuTag"
                     CheckTest = True
                     QUITLOOP
                  ENDIF
               ENDFOR
               IF NOT CheckTest THEN
                  MESSAGE "This is NOT an ORIGINAL Menu item!"
                  SLEEP 1500
                  MESSAGE ""
               ENDIF
               RETURN
          ENDSWITCH
   ENDSWITCH
Endproc

; ------------------------------------------------------------
;+ 02-10-95 08:00:38am
;+ Center for Information Management
; ------------------------------------------------------------
Proc CustMenuDlg()
   Private ProcName
   ProcName = "CustMenuDlg"
   ; PaintPAL_Generated_Code_Begin(507462741)

   ; PaintPAL_Color_Setup_Begin
   GETCOLORS TO PaintPAL.OriginalPalette
   DYNARRAY PaintPAL.ColorDeviations[]
   PaintPAL.ColorDeviations[1056] =  27  ;Picklist Normal
   PaintPAL.ColorDeviations[1057] =  79  ;Picklist Focused
   PaintPAL.ColorDeviations[1058] =  30  ;Picklist Selected
   SETCOLORS FROM PaintPAL.ColorDeviations
   RELEASE VARS PaintPAL.ColorDeviations
   ; PaintPAL_Color_Setup_End

   SHOWDIALOG "Customize Utility Menu"
      PROC "CustMenuDlgProc"
         TRIGGER "ARRIVE", "UPDATE", "SELECT"

      @2,0 HEIGHT 23 WIDTH 80

      PAINTCANVAS FILL "" ATTRIBUTE 120 0,0,12,77

      PAINTCANVAS FILL "" ATTRIBUTE 120 18,0,20,77

      ; PaintPAL_Frame_Begin
      FRAME SINGLE FROM 13,0 TO 18,77
      PAINTCANVAS ATTRIBUTE 112 13,0,13,77
      PAINTCANVAS ATTRIBUTE 127 18,0,18,77
      PAINTCANVAS ATTRIBUTE 112 13,0,18,0
      PAINTCANVAS ATTRIBUTE 127 13,77,18,77
      ; PaintPAL_Frame_End

      ; PaintPAL_Frame_Begin
      FRAME SINGLE FROM 0,6 TO 7,32
      PAINTCANVAS ATTRIBUTE 112 0,6,0,32
      PAINTCANVAS ATTRIBUTE 127 7,6,7,32
      PAINTCANVAS ATTRIBUTE 112 0,6,7,6
      PAINTCANVAS ATTRIBUTE 127 0,32,7,32
      ; PaintPAL_Frame_End

      ; PaintPAL_Frame_Begin
      FRAME SINGLE FROM 0,45 TO 7,71
      PAINTCANVAS ATTRIBUTE 112 0,45,0,71
      PAINTCANVAS ATTRIBUTE 127 7,45,7,71
      PAINTCANVAS ATTRIBUTE 112 0,45,7,45
      PAINTCANVAS ATTRIBUTE 127 0,71,7,71
      ; PaintPAL_Frame_End

      ; PaintPAL_Static_Text_Begin
      PAINTCANVAS FILL " " ATTRIBUTE 112 0,7,0,19
      @0,7
      ?? "Current Menu"
      PAINTCANVAS ATTRIBUTE 112 0,7,0,19
      ; PaintPAL_Static_Text_End

      ; PaintPAL_Static_Text_Begin
      PAINTCANVAS FILL " " ATTRIBUTE 112 0,46,0,54
      @0,46
      ?? "New Menu"
      PAINTCANVAS ATTRIBUTE 112 0,46,0,54
      ; PaintPAL_Static_Text_End

      ; PaintPAL_Static_Text_Begin
      PAINTCANVAS FILL " " ATTRIBUTE 112 9,0,10,15
      @9,0
      ?? "Menu Item Detail"
      @10,0
      ?? ""
      PAINTCANVAS ATTRIBUTE 112 9,0,10,15
      ; PaintPAL_Static_Text_End

      ; PaintPAL_Static_Text_Begin
      PAINTCANVAS FILL " " ATTRIBUTE 112 13,1,13,39
      @13,1
      ?? "Add New Menu Item/Edit Menu Item Detail"
      PAINTCANVAS ATTRIBUTE 112 13,1,13,39
      ; PaintPAL_Static_Text_End

      PUSHBUTTON @7,25 WIDTH 6
         ""
         VALUE "Add"
         TAG "AddButtonTag"
         TO WhichButton

      PICKARRAY @1,7 HEIGHT 6 WIDTH 24
         UtilMenu
         TAG "UtilMenuTag"
         TO UtilMenuVar

      PICKARRAY @1,46 HEIGHT 6 WIDTH 24
         TempMenu
         TAG "TempMenuTag"
         TO TempMenuVar

      PICKARRAY @10,0 HEIGHT 3 WIDTH 78
         ItemDetail
         TAG "ItemDetailTag"
         TO ItemDetailVar

      ACCEPT @14,15 WIDTH 43
         "A40"
         TAG "ItemTag"
         TO ItemVar

      LABEL @14,8
         "Item: "
         FOR "ItemTag"

      ACCEPT @15,15 WIDTH 61
         "A58"
         TAG "DescTag"
         TO DescVar

      LABEL @15,1
         "Description: "
         FOR "DescTag"

      ACCEPT @16,15 WIDTH 33
         "A30"
         TAG "ItemTagTag"
         TO ItemTagVar

      LABEL @16,4
         "Item Tag: "
         FOR "ItemTagTag"

      ACCEPT @17,15 WIDTH 11
         "A8"
         TAG "ScriptTag"
         TO ScriptVar

      LABEL @17,6
         "Script: "
         FOR "ScriptTag"

      PUSHBUTTON @19,53 WIDTH 10
         "~O~k"
         OK
         VALUE "Ok"
         TAG "OkButtonTag"
         TO WhichButton

      PUSHBUTTON @19,66 WIDTH 10
         "~C~ancel"
         CANCEL
         VALUE "Cancel"
         TAG "CancelButtonTag"
         TO WhichButton

      PUSHBUTTON @7,45 WIDTH 6
         ""
         VALUE "Remove"
         TAG "RemoveButtonTag"
         TO WhichButton

      PUSHBUTTON @19,2 WIDTH 11
         "~A~dd New"
         VALUE "AddNew"
         TAG "AddNewButtonTag"
         TO WhichButton

      PUSHBUTTON @7,52 WIDTH 11
         "~D~el New"
         VALUE "DeleteNew"
         TAG "DelNewButtonTag"
         TO WhichButton

      PUSHBUTTON @7,8 WIDTH 8
         "~E~dit"
         VALUE "EditCur"
         TAG "EditCurButtonTag"
         TO WhichButton

      PUSHBUTTON @19,16 WIDTH 20
         "~S~ave Edited Item"
         VALUE "Save"
         TAG "SaveButtonTag"
         TO WhichButton

      PUSHBUTTON @7,64 WIDTH 8
         "Ed~i~t"
         VALUE "EditNew"
         TAG "EditNewButtonTag"
         TO WhichButton

      PUSHBUTTON @19,40 WIDTH 9
         "~H~elp!"
         VALUE "HelpMe"
         TAG "HelpButtonTag"
         TO WhichButton
   ENDDIALOG

   ; PaintPAL_Color_Cleanup_Begin
   SETCOLORS FROM PaintPAL.OriginalPalette
   RELEASE VARS PaintPAL.OriginalPalette
   ; PaintPAL_Color_Cleanup_End

   ; PaintPAL_Generated_Code_End(507462741)
Endproc

; ------------------------------------------------------------
;+ 01-31-95 05:19:08pm
;+ Center for Information Management
; ------------------------------------------------------------
Proc CustMenu()
   Private ProcName
   ProcName = "CustMenu"
   ; Declare and initialize arrays for present custom utility menu
   PLAY "MENARRAY"

   ; Declare and initialize arrays for storage of new utility menu
   Array TempMenu[20]
   TempMenu[1]  = ""
   TempMenu[2]  = ""
   TempMenu[3]  = ""
   TempMenu[4]  = ""
   TempMenu[5]  = ""
   TempMenu[6]  = ""
   TempMenu[7]  = ""
   TempMenu[8]  = ""
   TempMenu[9]  = ""
   TempMenu[10] = ""
   TempMenu[11] = ""
   TempMenu[12] = ""
   TempMenu[13] = ""
   TempMenu[14] = ""
   TempMenu[15] = ""
   TempMenu[16] = ""
   TempMenu[17] = ""
   TempMenu[18] = ""
   TempMenu[19] = ""
   TempMenu[20] = ""

   Array TempMenuDesc[20]
   TempMenuDesc[1]  = ""
   TempMenuDesc[2]  = ""
   TempMenuDesc[3]  = ""
   TempMenuDesc[4]  = ""
   TempMenuDesc[5]  = ""
   TempMenuDesc[6]  = ""
   TempMenuDesc[7]  = ""
   TempMenuDesc[8]  = ""
   TempMenuDesc[9]  = ""
   TempMenuDesc[10] = ""
   TempMenuDesc[11] = ""
   TempMenuDesc[12] = ""
   TempMenuDesc[13] = ""
   TempMenuDesc[14] = ""
   TempMenuDesc[15] = ""
   TempMenuDesc[16] = ""
   TempMenuDesc[17] = ""
   TempMenuDesc[18] = ""
   TempMenuDesc[19] = ""
   TempMenuDesc[20] = ""

   Array TempMenuTag[20]
   TempMenuTag[1]  = ""
   TempMenuTag[2]  = ""
   TempMenuTag[3]  = ""
   TempMenuTag[4]  = ""
   TempMenuTag[5]  = ""
   TempMenuTag[6]  = ""
   TempMenuTag[7]  = ""
   TempMenuTag[8]  = ""
   TempMenuTag[9]  = ""
   TempMenuTag[10] = ""
   TempMenuTag[11] = ""
   TempMenuTag[12] = ""
   TempMenuTag[13] = ""
   TempMenuTag[14] = ""
   TempMenuTag[15] = ""
   TempMenuTag[16] = ""
   TempMenuTag[17] = ""
   TempMenuTag[18] = ""
   TempMenuTag[19] = ""
   TempMenuTag[20] = ""

   Array TempMenuScript[20]
   TempMenuScript[1]  = ""
   TempMenuScript[2]  = ""
   TempMenuScript[3]  = ""
   TempMenuScript[4]  = ""
   TempMenuScript[5]  = ""
   TempMenuScript[6]  = ""
   TempMenuScript[7]  = ""
   TempMenuScript[8]  = ""
   TempMenuScript[9]  = ""
   TempMenuScript[10] = ""
   TempMenuScript[11] = ""
   TempMenuScript[12] = ""
   TempMenuScript[13] = ""
   TempMenuScript[14] = ""
   TempMenuScript[15] = ""
   TempMenuScript[16] = ""
   TempMenuScript[17] = ""
   TempMenuScript[18] = ""
   TempMenuScript[19] = ""
   TempMenuScript[20] = ""

   ; Declare and initialize array to display menu item detail information
   Array ItemDetail[2]
   ItemDetail[1] = "Description                                Tag Value      Script"
   ItemDetail[2] = ""

   ItemVar = ""
   DescVar = ""
   ItemTagVar = ""
   ScriptVar = ""

   ; Remove the application's pulldown menu if one exists
   SHOWPULLDOWN ENDMENU
   ; Run the Custom Utility Menu tool
   CustMenuDlg()

   ; If "Ok" button is selected
   IF RetVal THEN
      X = -1
      ; Search for any New Menu items which are not blank
      FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
         IF TempMenu[Element] <> "" THEN
            X = Element
            QUITLOOP
         ENDIF
      ENDFOR
      SWITCH
         CASE X = -1:
             ;IF X = -1 THEN
             ; If all New Menu items are blank, warn the user
             IF NOT HelpYesNo() THEN
                RETURN
             ENDIF
             ;ENDIF
         OTHERWISE:
            ; Re-order temporary arrays to eliminate spaces in the menu structure
            FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
                IF TempMenu[Element] = "" THEN
                   FOR NextItem FROM Element TO ARRAYSIZE(TempMenu)
                        IF TempMenu[NextItem] <> "" THEN
                           TempMenu[Element] = TempMenu[NextItem]
                           TempMenuDesc[Element] = TempMenuDesc[NextItem]
                           TempMenuTag[Element] = TempMenuTag[NextItem]
                           TempMenuScript[Element] = TempMenuScript[NextItem]
                           TempMenu[NextItem] = ""
                           TempMenuDesc[NextItem] = ""
                           TempMenuTag[NextItem] = ""
                           TempMenuScript[NextItem] = ""
                        ENDIF
                   ENDFOR
                ENDIF
            ENDFOR
      ENDSWITCH
      MESSAGE "Setting Up Script For CUSTOM UTILITY MENU"

      ;Write the NEW Custom Utility Menu Script from the Arrays

      FileName = "UTILMENU.SC"
      FILEWRITE FileName FROM "; Custom Utility Menu Script built by user\n"
      ; Remove application's pulldown menu if one exists
      FILEWRITE FileName FROM "SHOWPULLDOWN ENDMENU\n"
      ; Display the menu until Exit is selected
      FILEWRITE APPEND FileName FROM "WHILE True\n"
      FILEWRITE APPEND FileName FROM "   SHOWPOPUP \"Custom Utility Menu\" CENTERED\n"
      FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
         IF TempMenu[Element] = "" THEN
            QUITLOOP
         ELSE
            ; Check if the menu element is Separator to determine what to
            ; write to the file
            IF UPPER(TempMenu[Element]) = "SEPARATOR" THEN
               FILEWRITE APPEND FileName FROM "      "+TempMenu[Element]+",\n"
            ELSE
               FILEWRITE APPEND FileName FROM "      \""+TempMenu[Element]+"\":\""+
                                          TempMenuDesc[Element]+"\":\""+
                                          TempMenuTag[Element]+"\",\n"
            ENDIF
         ENDIF
      ENDFOR
      ; Add the E~x~it item to the menu
      FILEWRITE APPEND FileName FROM "      \"E~x~it\" : \"Exit Custom Utility Menu\" : \"ExitTag\"\n"
      FILEWRITE APPEND FileName FROM "   ENDMENU\n"
      FILEWRITE APPEND FileName FROM "   TO PopChoice\n\n"
      ; Create SWITCH statement to respond to menu selections
      FILEWRITE APPEND FileName FROM "   SWITCH\n"
      FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
         ; Write out information until a blank menu item is found
         IF TempMenu[Element] = "" THEN
            QUITLOOP
         ELSE
            IF TempMenuScript[Element] <> "" THEN
               FILEWRITE APPEND FileName FROM "      CASE PopChoice = \""+TempMenuTag[Element]+"\":\n"+
                                          "         PLAY \""+TempMenuScript[Element]+"\"\n"
            ENDIF
         ENDIF
      ENDFOR
      FILEWRITE APPEND FileName FROM "      CASE PopChoice = \"ExitTag\":\n"
      FILEWRITE APPEND FileName FROM "         RETURN\n"
      FILEWRITE APPEND FileName FROM "   ENDSWITCH\n"
      FILEWRITE APPEND FileName FROM "ENDWHILE"

      MESSAGE "Setting Up Script For Custom Utility Menu Array Definitions"

      ; Write the NEW Array Script which declares the Custom Utility Menu Arrays

      FileName = "MENARRAY.SC"
      FILEWRITE FileName FROM "; Arrays to be used for Custom Utility Menu"

      FILEWRITE APPEND FileName FROM "\nArray UtilMenu[20]\n"
      FOR Element FROM 1 TO ARRAYSIZE(TempMenu)
         FILEWRITE APPEND FileName FROM "  UtilMenu["+STRVAL(Element)+"] = \""+ TempMenu[Element] + "\"\n"
      ENDFOR
      FILEWRITE APPEND FileName FROM "\nArray UtilMenuDesc[20]\n"
      FOR Element FROM 1 TO ARRAYSIZE(TempMenuDesc)
         FILEWRITE APPEND FileName FROM "  UtilMenuDesc["+STRVAL(Element)+"] = \""+ TempMenuDesc[Element] + "\"\n"
      ENDFOR
      FILEWRITE APPEND FileName FROM "\nArray UtilMenuTag[20]\n"
      FOR Element FROM 1 TO ARRAYSIZE(TempMenuTag)
         FILEWRITE APPEND FileName FROM "  UtilMenuTag["+STRVAL(Element)+"] = \""+ TempMenuTag[Element] + "\"\n"
      ENDFOR
      FILEWRITE APPEND FileName FROM "\nArray UtilMenuScript[20]\n"
      FOR Element FROM 1 TO ARRAYSIZE(TempMenuScript)
         FILEWRITE APPEND FileName FROM "  UtilMenuScript["+STRVAL(Element)+"] = \""+ TempMenuScript[Element] + "\"\n"
      ENDFOR
      RELEASE VARS UtilMenu, UtilMenuDesc, UtilMenuTag, UtilMenuScript
      RELEASE VARS TempMenu, TempMenuDesc, TempMenuTag, TempMenuScript, ItemDetail
      MESSAGE ""
   ENDIF
Endproc

CustMenu()

